package com.jmsexample;

import org.apache.activemq.command.ActiveMQObjectMessage;
import org.apache.activemq.ActiveMQConnectionFactory;

import javax.jms.*;

/**
 * User: Administrator
 * Date: 03.05.2009
 * Time: 19:31:28
 */
/*
    Client starts the connection, sends values in ObjectMessage to server. Then recieves the response and print it.
 */

public class ClientThread extends Thread {
    private QueueSession queueSession;
    private static Object LOCK_OBJECT = new Object();
    private static Integer finished = 0;


    public ClientThread() throws JMSException {
        ConnectionFactory factory = new ActiveMQConnectionFactory(Constants.BROKER_URL);
        Connection jmsConnection = factory.createConnection();
        jmsConnection.start();
        System.out.println("Connection started");
        queueSession = ((QueueConnection) jmsConnection).createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
    }

    @Override
    public void run() {
        try {
            Queue outgoingQueue = queueSession.createQueue(Constants.QUEUE_NAME);
            ObjectMessage outgoingMessage = new ActiveMQObjectMessage();

            TemporaryQueue incomingQueue = queueSession.createTemporaryQueue();
            MessageConsumer consumer = queueSession.createConsumer(incomingQueue);

            outgoingMessage.setJMSReplyTo(incomingQueue);
            outgoingMessage.setObject(new Integer[]{1, 2, 3});
            MessageProducer producer = queueSession.createProducer(outgoingQueue);
            producer.send(outgoingQueue, outgoingMessage);

            Message message = consumer.receive();
            ObjectMessage objectMessage = (ObjectMessage) message;
            System.out.println("" + objectMessage.getObject());
            incFinishedCount();
        } catch (JMSException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    private static void incFinishedCount(){
        synchronized (LOCK_OBJECT){
            ++finished;
        }
    }

    public static void main(String[] args) {
        try {
            System.out.println("Connection started");
            int clientsCount = 100;
            for (int i = 0; i < clientsCount; i++) {
                new ClientThread().start();
            }
            while (clientsCount > finished ){
                //do nothing
            }
            System.out.println("Finished");
        } catch (JMSException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }
}
