package com.jmsexample;

import org.apache.activemq.command.ActiveMQObjectMessage;
import org.apache.activemq.ActiveMQConnectionFactory;

import javax.jms.*;

/**
 * User: Administrator
 * Date: 03.05.2009
 * Time: 19:33:28
 */

/*
    Server recievs message from client, incremnt values and push the resulkt back to client
 */

public class ServerThread extends Thread {
    private MessageProducer replyProducer;

    public ServerThread() throws JMSException {
        ConnectionFactory factory = new ActiveMQConnectionFactory(Constants.BROKER_URL);
        Connection jmsConnection = factory.createConnection();
        jmsConnection.start();
        QueueSession session = ((QueueConnection) jmsConnection).createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
        Destination adminQueue = session.createQueue(Constants.QUEUE_NAME);
        replyProducer = session.createProducer(null);
        replyProducer.setDeliveryMode(DeliveryMode.NON_PERSISTENT);
        MessageConsumer consumer = session.createConsumer(adminQueue);
        consumer.setMessageListener(new MessageListener() {
            public void onMessage(Message message) {
                new Thread(new OnMessageRunnable(message)).start();
            }
        });
    }

    @Override
    public void run() {

    }

    private class OnMessageRunnable implements Runnable {
        private Message message;

        public OnMessageRunnable(Message message) {
            this.message = message;
        }

        public void run() {
            try {
                ObjectMessage incomingMessage = (ObjectMessage) message;
                Integer[] vals = (Integer[]) incomingMessage.getObject();
                Integer result = 0;
                for (Integer val : vals) {
                    result += val;
                }

                Destination outgoingDestination = message.getJMSReplyTo();

                ObjectMessage outgoingMessage = new ActiveMQObjectMessage();
                outgoingMessage.setObject(result);

                replyProducer.send(outgoingDestination, outgoingMessage);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public static void main(String[] args) {
        try {

            new ServerThread().start();
        } catch (JMSException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

}
